unit CalemdarGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Inifiles, StdCtrls, ExtCtrls, Vcl.ComCtrls, DateUtils,
  Vcl.Imaging.pngimage, Vcl.Menus, kbmMemSQL, Data.DB, kbmMemTable,
  kbmMemCSVStreamFormat, kbmMemBinaryStreamFormat, Vcl.DBCtrls, Vcl.Grids,
  Vcl.DBGrids, VCLTee.TeCanvas, ColorButton, uxTheme, Vcl.Mask,
  Vcl.WinXCalendars ;

type
  TCalendarFrm = class(TForm)
    Timer1: TTimer;
    LblTime: TLabel;
    LblDate: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LblWeekday: TLabel;
    PopupMenu1: TPopupMenu;
    CloseApp1: TMenuItem;
    DateOnly1: TMenuItem;
    Calendar1month1: TMenuItem;
    CalenderYear1: TMenuItem;
    Noborder1: TMenuItem;
    PanelRightTop: TPanel;
    Label1: TLabel;
    Image1: TImage;
    DataSource1: TDataSource;
    kbmBinaryStreamFormat1: TkbmBinaryStreamFormat;
    kbmMemTable1: TkbmMemTable;
    kbmMemTable1DateEvent: TDateField;
    kbmMemTable1TimeEvent: TTimeField;
    kbmMemTable1EventName: TStringField;
    ColorDialog1: TColorDialog;
    Panel2: TPanel;
    CV1: TCalendarView;
    PopMenuDataform: TPopupMenu;
    ShowDate1: TMenuItem;
    Showalldates1: TMenuItem;
    CV2: TCalendarView;
    CV3: TCalendarView;
    CV4: TCalendarView;
    CV5: TCalendarView;
    CV6: TCalendarView;
    CV7: TCalendarView;
    CV8: TCalendarView;
    CV9: TCalendarView;
    CV10: TCalendarView;
    CV11: TCalendarView;
    CV12: TCalendarView;
    CV13: TCalendarView;
    CV14: TCalendarView;
    CV15: TCalendarView;
    CV16: TCalendarView;
    Panel1: TPanel;
    ColorButton1: TColorButton;
    ShowDataForm1: TMenuItem;
    ColorButton2: TColorButton;
    ColorButton3: TColorButton;
    ColorButton5: TColorButton;
    Edit1: TEdit;
    EditEvent: TEdit;
    ClrBtnAppoint: TColorButton;
    AppointmentForm1: TMenuItem;
    N1: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LblTimeClick(Sender: TObject);
    procedure LblDateClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure LblWeekdayClick(Sender: TObject);
    procedure ColorButton1Click(Sender: TObject);
    procedure Panel1MouseLeave(Sender: TObject);
    procedure Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ShowDataForm1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ColorButton5Click(Sender: TObject);
    procedure CV1DblClick(Sender: TObject);
    procedure CV2DblClick(Sender: TObject);
    procedure CV3DblClick(Sender: TObject);
    procedure CV4DblClick(Sender: TObject);
    procedure CV5DblClick(Sender: TObject);
    procedure CV6DblClick(Sender: TObject);
    procedure CV7DblClick(Sender: TObject);
    procedure CV8DblClick(Sender: TObject);
    procedure CV9DblClick(Sender: TObject);
    procedure CV10DblClick(Sender: TObject);
    procedure CV11DblClick(Sender: TObject);
    procedure CV12DblClick(Sender: TObject);
    procedure CV13DblClick(Sender: TObject);
    procedure CV14DblClick(Sender: TObject);
    procedure CV15DblClick(Sender: TObject);
    procedure CV16DblClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadDates;
  end;


var
  CalendarFrm: TCalendarFrm;

  C4D_RIO_appINI   : TIniFile;
  FN,KBM,Dir       : String;


implementation

{$R *.dfm}

uses SHFolder, shlObj, DataFrm;



function GetFolderPath(Wnd: HWnd; CSIDLFolder: Integer): string;
begin
  SetLength(Result, MAX_PATH);
  SHGetFolderPath(Wnd, CSIDLFolder, 0, 0, PChar(Result));
  SetLength(Result, StrLen(PChar(Result)));
  //specific for windows
  if (Result <> '') then Result  := IncludeTrailingBackslash(Result);
end;

function GetShellFolder(CSIDLFolder : integer) : string;
begin
  SetLength(Result, MAX_PATH);
  SHGetSpecialFolderPath(0, PChar(Result), CSIDLFolder, false);
  SetLength(Result, StrLen(PChar(Result)));
  //specific for windows
  if (Result <> '') then Result  := IncludeTrailingBackslash(Result);
end;

///////////////////////////// All form events //////////////////////////////////

procedure TCalendarFrm.FormCreate(Sender: TObject);
Var day    : array[1..7] of string;
begin
  /// set all necessary paths
  Dir:=GetFolderPath(0,CSIDL_LOCAL_APPDATA)+ 'Delphi_RIO_C4D';
  /// to show the path you can enable them
  Label3.Caption:=Dir;
  Label4.Caption:=GetShellFolder(CSIDL_LOCAL_APPDATA);
  // Dir:=Dir+ChangeFileExt(ExtractFileName(Application.ExeName),'');
  //  Dir:=Dir+ChangeFileExt(ExtractFileName(Application.ExeName),'');
  Label5.Caption:=Dir;
  If not ForceDirectories(Dir) then
    Raise Exception.CreateFmt('Failed to create settings directory %s',[Dir]);

  FN  := Dir+'\'+'C4D_RIO_appINI.ini';
  kbm := Dir+'\'+'Calendar_kbmMW_Binary.detlef';


  ///This is all for the smalleste form size
  LblTime.Caption:= TimeToStr(Now);
  LblDate.Caption:= DateToStr(Now);

  day[1] := 'Monday';
  day[2] := 'Tuesday';
  day[3] := 'Wednesday';
  day[4] := 'Thursday';
  day[5] := 'Friday';
  day[6] := 'Saturday';
  day[7] := 'Sunday';

  LblWeekday.Caption:= day[DayOfTheWeek(Now)];
  /// DayOfTheWeek is ISO 8601 compliant,
  /// since it uses Monday as the start of the week.

  ///To set all calendars to the tight months
  CV1.Visible  :=False;  CV1.Date := Now;
  CV2.Visible  :=False;  CV2.Date := incMonth(Date, 1);
  CV3.Visible  :=False;  CV3.Date := incMonth(Date, 2);
  CV4.Visible  :=False;  CV4.Date := incMonth(Date, 3);
  CV5.Visible  :=False;  CV5.Date := incMonth(Date, 4);
  CV6.Visible  :=False;  CV6.Date := incMonth(Date, 5);
  CV7.Visible  :=False;  CV7.Date := incMonth(Date, 6);
  CV8.Visible  :=False;  CV8.Date := incMonth(Date, 7);
  CV9.Visible  :=False;  CV9.Date := incMonth(Date, 8);
  CV10.Visible :=False;  CV10.Date:= incMonth(Date, 9);
  CV11.Visible :=False;  CV11.Date:= incMonth(Date,10);
  CV12.Visible :=False;  CV12.Date:= incMonth(Date,11);
  CV13.Visible :=False;  CV13.Date:= incMonth(Date,12);
  CV14.Visible :=False;  CV14.Date:= incMonth(Date,13);
  CV15.Visible :=False;  CV15.Date:= incMonth(Date,14);
  CV16.Visible :=False;  CV16.Date:= incMonth(Date,15);

  /// Activate the databse
  kbmMemTable1.Open;
  kbmMemTable1.Active;
  /// Set the name of the file where the data in is recorded
  /// These database e;lement are fre available

  kbmMemTable1.LoadFromFile(kbm);

  /// Free gift from Kim  Madsen
  ReportMemoryLeaksOnShutdown:=true;

  /// All the settings are recorded in C4D_RIO_appINI
  C4D_RIO_appINI := TIniFile.Create(ChangeFileExt(FN,'.ini')) ;
  try
    Top    := C4D_RIO_appINI.ReadInteger('Placement','Top', Top) ;
    Left   := C4D_RIO_appINI.ReadInteger('Placement','Left', Left);
    Width  := C4D_RIO_appINI.ReadInteger('Placement','Width', Width);
    Height := C4D_RIO_appINI.ReadInteger('Placement','Height', Height);
  finally
    C4D_RIO_appINI.Free;
  end;

  Height      :=  70;
  Width       := 210;
  Image1.Left := 155;

  if left +215 >= screen.Width
  then left := screen.Width - 240
  else
  If left +215 <= screen.Width
  then left:=Left;
end;
{------------------------------------------------------------------------------}
procedure TCalendarFrm.FormClick(Sender: TObject);
begin
  if BorderStyle = bsToolWindow
  then
    begin
      Height      :=  98;
      Width       := 215;
      Image1.Left := 155;
    end
  else
    begin
      Height      := 70;
      Width       := 210;
      Image1.Left := 155;
    end;
end;
{------------------------------------------------------------------------------}
procedure TCalendarFrm.FormDblClick(Sender: TObject);
begin
   /// large view: 16 months show
  CV1.Visible  :=True;
  CV2.Visible  :=True;
  CV3.Visible  :=True;
  CV4.Visible  :=True;
  CV5.Visible  :=True;
  CV6.Visible  :=True;
  CV7.Visible  :=True;
  CV8.Visible  :=True;
  CV9.Visible  :=True;
  CV10.Visible :=True;
  CV11.Visible :=True;
  CV12.Visible :=True;
  CV13.Visible :=True;
  CV14.Visible :=True;
  CV15.Visible :=True;
  CV16.Visible :=True;


  BorderStyle := bsNone;
  Height      := 840;//750;
  Width       := 825;
  Image1.Left := 753;


  if (left + 260 > screen.Width)
  then left := left- 615
  else left := left;

  Edit1.Left      := 173;
  Edit1.Top       := 805;

  EditEvent.Top   := 805;
  EditEvent.Width := 408;
  EditEvent.Left  := 258;

  ClrBtnAppoint.Visible := False;

end;
{------------------------------------------------------------------------------}
procedure TCalendarFrm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Panel1.Visible := false
end;

procedure TCalendarFrm.FormShow(Sender: TObject);
begin
  LoadDates
end;
{------------------------------------------------------------------------------}
procedure TCalendarFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If (kbmMemTable1.State in [dsEdit, dsInsert]) then kbmMemTable1.Post;

  //kbmMemTable1.saveToFile('Calendar_kbmMW_Binary.detlef');
  kbmMemTable1.saveToFile(kbm);


  C4D_RIO_appINI := TIniFile.Create(ChangeFileExt(Fn,'.ini')) ;
  try
  with C4D_RIO_appINI, CalendarFrm do
    begin
      WriteInteger('Placement','Top', Top) ;
      WriteInteger('Placement','Left', Left) ;
      WriteInteger('Placement','Width', Width) ;
      WriteInteger('Placement','Height', Height) ;
    end;
  finally
    C4D_RIO_appINI.Free;
  end;
end;

/////////////////////// Loading the registered data and events//////////////////

procedure TCalendarFrm.LoadDates;
Var I,D: Integer;  DA: Array of Tdate;
begin
  // CV1 ////////////
  CV1.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);   /// necessary for the array lenth
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      /// The Truncate procedure truncates a file at the current file position.
      /// All data after the current file position is erased.

      Next /// Repetition
    End;
  End;
  /// Add the selected data - array
  CV1.AddToSelectedDates (DA);

  // This is repeated for each calendar

  // CV2 ////////////
  CV2.Visible  :=True;
   SetLength (DA, kbmMemTable1.RecordCount);
   With kbmMemTable1 Do
   Begin
     First;
     for D := 0 to RecordCount -1 do
     Begin
        DA[D] := trunc(FieldByName('DateEvent').asdatetime);
        Next
     End;
   End;
   CV2.AddToSelectedDates (DA);

  // CV3 ////////////
  CV3.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV3.AddToSelectedDates (DA);

  // CV4 ////////////
  CV4.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;

  CV4.AddToSelectedDates (DA);

  // CV5 ////////////
  CV5.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV5.AddToSelectedDates (DA);

  // CV6 ////////////
  CV6.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV6.AddToSelectedDates (DA);

  // CV7 ////////////
  CV7.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;

  CV7.AddToSelectedDates (DA);

  // CV8 ////////////
  CV8.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV8.AddToSelectedDates (DA);

  // CV9 ////////////
  CV9.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV9.AddToSelectedDates (DA);

  // CV10 ////////////
  CV10.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV10.AddToSelectedDates (DA);

  // CV11 ////////////
  CV11.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV11.AddToSelectedDates (DA);

  //  CV12 ////////////
  CV12.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;

  CV12.AddToSelectedDates (DA);

 // CV13 ////////////
  CV13.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV13.AddToSelectedDates (DA);

  // CV14 ////////////
  CV14.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV14.AddToSelectedDates (DA);

  // CV15 ////////////
  CV15.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV15.AddToSelectedDates (DA);

  // CV16 ////////////
  CV16.Visible  :=True;
  SetLength (DA, kbmMemTable1.RecordCount);
  With kbmMemTable1 Do
  Begin
    First;
    for D := 0 to RecordCount -1 do
    Begin
      DA[D] := trunc(FieldByName('DateEvent').asdatetime);
      Next
    End;
  End;
  CV16.AddToSelectedDates (DA);
end;

/// the above part can be extracted into a separate form.

////////////////////////////////////////////////////////////////////////////////

procedure TCalendarFrm.Timer1Timer(Sender: TObject);
begin
  /// Clock settings
  LblTime.Caption:= TimeToStr(Now);
  LblDate.Caption:= DateToStr(Now);
end;

procedure TCalendarFrm.LblTimeClick(Sender: TObject);
begin
  /// Create a windowsform element so you can drag and drop the item
  /// at any place you want
  BorderStyle := bsToolWindow;
  Image1.Left := 155;
  Height      := 99;
  Width       := 215;
end;

procedure TCalendarFrm.LblDateClick(Sender: TObject);
begin
  /// Create a non windows form element , it has no border
  BorderStyle := bsNone;
  Image1.Left := 155;
  Height      := 68;
  Width       := 210;
end;

procedure TCalendarFrm.LblWeekdayClick(Sender: TObject);
begin
  /// 1 month show
  BorderStyle     := bsNone;
  Image1.Left     := 150;
  Height          := 300;
  Width           := 210;

  Edit1.Left      :=   6;
  Edit1.Top       := 248;

  EditEvent.Top   := 272;
  EditEvent.Width := 202;
  EditEvent.Left  :=   6;

  CV1.Visible     :=True;
  CV5.Visible     :=False;

  ClrBtnAppoint.Visible := True;
  ClrBtnAppoint.left :=    85;
  ClrBtnAppoint.Top := 247;
end;

procedure TCalendarFrm.Panel1MouseLeave(Sender: TObject);
begin
  /// Setting the buttons at the bottom to not visble
  Panel1.Visible := False
end;

procedure TCalendarFrm.Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  /// Setting the buttons at the bottom to visble
  Panel1.Visible := True
end;

procedure TCalendarFrm.ShowDataForm1Click(Sender: TObject);
begin
  ///if not exists create the form
  If FrmData = Nil Then FrmData := TFrmData.Create(Self);
  FrmData.Show;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TCalendarFrm.Image1Click(Sender: TObject);
begin
  /// Extra ability to clos teh form
  if left >= screen.Width - 240
  then
    begin
      left := screen.Width - 240 ;
      CalendarFrm.Close;
    end
  else
  If left <= screen.Width - 240
  then begin
     left:=Left;
     CalendarFrm.Close;
  end;

end;

////////////////////////////////////////////////////////////////////////////////

procedure TCalendarFrm.CV1DblClick(Sender: TObject);
begin
  if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV1.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

   if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      Exit
    end
   else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV2DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV2.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
    else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV3DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV3.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
    else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV4DblClick(Sender: TObject);
begin
  if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV4.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
    else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV5DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV5.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV6DblClick(Sender: TObject);
begin
    if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV6.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV7DblClick(Sender: TObject);
begin
    if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV7.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV8DblClick(Sender: TObject);
begin
  if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV8.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV9DblClick(Sender: TObject);
begin
    if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV9.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV10DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV10.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
    else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;

end;

procedure TCalendarFrm.CV11DblClick(Sender: TObject);
begin
  if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV11.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
     else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV12DblClick(Sender: TObject);
begin
  if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV12.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
  else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV13DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV13.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
    else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV14DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV14.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
  else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV15DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV15.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
  else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

procedure TCalendarFrm.CV16DblClick(Sender: TObject);
begin
   if Edit1.Text = '' then
    begin
      showmessage('add the time');
      Exit;
    end
  else
    begin
      kbmMemTable1.Edit;
      kbmMemTable1.append;
      kbmMemTable1.FieldByName('DateEvent').AsDateTime := (CV16.Date);
      kbmMemTable1.FieldByName('TimeEvent').AsDateTime := StrToDateTime(Edit1.Text);
    end;

  if EditEvent.Text = '' then
    begin
      showmessage('add the event name');
      EditEvent.Text;
      exit;
    end
   else
    begin
      kbmMemTable1.FieldByName('EventName').AsString   := EditEvent.Text;
      ColorButton5Click(sender);
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TCalendarFrm.ColorButton5Click(Sender: TObject);
begin
  /// Creating the form
  If FrmData = Nil Then FrmData := TFrmData.Create(Self);
  FrmData.Show;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TCalendarFrm.ColorButton1Click(Sender: TObject);
begin
  /// Changing the form color
  if ColorDialog1.execute then CalendarFrm.Color :=  ColorDialog1.Color;
end;

end.
